>From 770cfc84d51199fd1059a9d6a9261fd1a9961d9b Mon Sep 17 00:00:00 2001
From: Bryan Kearney <bkearney@localhost.localdomain>
Date: Wed, 6 Jan 2010 11:51:04 -0500
Subject: [PATCH] Upgrade the hibernate version. The following versions are now being used:

Hibernate Core 3.3.2.GA
Hibernate JMX 3.3.1.GA
Hibernate Commons Annotatoins 3.1.0.GA
Hibernate Annotations 3.4.0.GA
Hibernate Entity Manager 3.4.0.GA
Hibernate Validator Legacy 4.0.2.GA
---
 .classpath                                         |    9 +++-
 modules/core/domain/pom.xml                        |   37 ++++++++++---
 modules/core/gui/pom.xml                           |   11 +++-
 modules/core/plugindoc/ant-run.xml                 |    2 +-
 modules/core/plugindoc/pom.xml                     |    5 +-
 modules/enterprise/gui/portal-war/pom.xml          |    8 ++--
 modules/enterprise/gui/webdav-war/pom.xml          |    8 ++--
 modules/enterprise/remoting/cli/pom.xml            |    7 ++-
 modules/enterprise/remoting/client-api/pom.xml     |    3 +-
 modules/enterprise/server/container/pom.xml        |   16 +++++-
 .../src/main/scripts/rhq-container.build.xml       |   27 +++++++++-
 modules/enterprise/server/jar/pom.xml              |   26 +++++++---
 modules/enterprise/server/safe-invoker/pom.xml     |    6 +-
 modules/plugins/snmptrapd/pom.xml                  |    2 +-
 pom.xml                                            |   53 ++++++++++++++++---
 15 files changed, 169 insertions(+), 51 deletions(-)

diff --git a/.classpath b/.classpath
index a07522a..878f625 100644
--- a/.classpath
+++ b/.classpath
@@ -169,7 +169,6 @@
 	<classpathentry exported="true" kind="var" path="M2_REPO/javax/xml/bind/jsr173_api/1.0/jsr173_api-1.0.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/jboss/jboss-embeddable-ejb3/jboss-ejb3-all/1.0.0.Alpha9/jboss-ejb3-all-1.0.0.Alpha9.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/jboss/jbpm/3.1.1/jbpm-3.1.1.jar"/>
-	<classpathentry exported="true" kind="var" path="M2_REPO/jboss/jboss-embeddable-ejb3/hibernate-all/1.0.0.Alpha9/hibernate-all-1.0.0.Alpha9.jar" sourcepath="/M2_REPO/hibernate/hibernate3/3.2.r14201-2/hibernate3-3.2.r14201-2.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/org/jetbrains/annotations/7.0.2/annotations-7.0.2.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/ant/ant-launcher/1.6.5/ant-launcher-1.6.5.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/cglib/cglib-nodep/2.1_3/cglib-nodep-2.1_3.jar"/>
@@ -203,7 +202,6 @@
 	<classpathentry exported="true" kind="var" path="M2_REPO/org/freemarker/freemarker/2.3.11/freemarker-2.3.11.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/org/jboss/seam/jboss-seam/2.1.0.SP1/jboss-seam-2.1.0.SP1.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/org/jboss/seam/jboss-seam-ui/2.1.0.SP1/jboss-seam-ui-2.1.0.SP1.jar"/>
-	<classpathentry exported="true" kind="var" path="M2_REPO/hibernate/hibernate3/3.2.r14201-2/hibernate3-3.2.r14201-2.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/jline/jline/0.9.94/jline-0.9.94.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/com/ettrema/milton-api/1.4.1/milton-api-1.4.1.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/jboss/javassist/3.8.0.GA/javassist-3.8.0.GA.jar"/>
@@ -222,5 +220,12 @@
 	<classpathentry exported="true" kind="var" path="M2_REPO/org/hamcrest/hamcrest-library/1.1/hamcrest-library-1.1.jar"/>
 	<classpathentry exported="true" kind="var" path="M2_REPO/org/jboss/byteman/byteman/1.2.1/byteman-1.2.1.jar"/>
 	<classpathentry exported="true" kind="lib" path="modules/enterprise/remoting/webservices/target/rhq-remoting-webservices-1.4.0-SNAPSHOT/wsconsume-output"/>
+	<classpathentry exported="true" kind="var" path="M2_REPO/org/hibernate/hibernate-core/3.3.2.GA/hibernate-core-3.3.2.GA.jar"/>
+	<classpathentry exported="true" kind="var" path="M2_REPO/org/hibernate/hibernate-jmx/3.3.2.GA/hibernate-jmx-3.3.2.GA.jar"/>    
+	<classpathentry exported="true" kind="var" path="M2_REPO/org/hibernate/hibernate-commons-annotations/3.1.0.GA/hibernate-commons-annotations-3.1.0.GA.jar"/>    
+	<classpathentry exported="true" kind="var" path="M2_REPO/org/hibernate/hibernate-annotations/3.4.0.GA/hibernate-annotations-3.4.0.GA.jar"/>     
+	<classpathentry exported="true" kind="var" path="M2_REPO/org/hibernate/hibernate-entitymanager/3.4.0.GA/hibernate-entitymanager-3.4.0.GA.jar"/>         
+	<classpathentry exported="true" kind="var" path="M2_REPO/org/hibernate/hibernate-validator-legacy/4.0.2.GA/hibernate-validator-legacy-4.0.2.GA.jar"/>      
+    <classpathentry exported="true" kind="var" path="M2_REPO/org/antlr/antlr-runtime/3.2/antlr-runtime-3.2.jar"/>    
 	<classpathentry kind="output" path="eclipse-classes"/>
 </classpath>
diff --git a/modules/core/domain/pom.xml b/modules/core/domain/pom.xml
index 53d16e5..81cda2b 100644
--- a/modules/core/domain/pom.xml
+++ b/modules/core/domain/pom.xml
@@ -38,14 +38,21 @@
 
       <!-- required by PersistenceUtil -->
       <dependency>
-         <groupId>hibernate</groupId>
-         <artifactId>hibernate3</artifactId>
+         <groupId>org.hibernate</groupId>
+         <artifactId>hibernate-core</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
       </dependency>
 
       <dependency>
-         <groupId>hibernate-annotations</groupId>
+         <groupId>org.hibernate</groupId>
+         <artifactId>hibernate-jmx</artifactId>
+         <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
+         <scope>provided</scope> <!-- by JBossAS -->
+      </dependency>
+
+      <dependency>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-annotations</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
@@ -53,13 +60,25 @@
 
       <!-- required by PersistenceUtil and EJB3 Embedded -->
       <dependency>
-         <groupId>hibernate-entitymanager</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-entitymanager</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
       </dependency>
 
       <dependency>
+         <groupId>org.slf4j</groupId>
+         <artifactId>slf4j-api</artifactId>
+         <scope>provided</scope>
+      </dependency>
+
+      <dependency>
+         <groupId>org.slf4j</groupId>
+         <artifactId>slf4j-log4j12</artifactId>
+         <scope>provided</scope>
+      </dependency>
+
+      <dependency>
          <groupId>javax.persistence</groupId>
          <artifactId>persistence-api</artifactId>
          <version>1.0</version>
@@ -98,7 +117,7 @@
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>test</scope>
       </dependency>
-      
+
       <dependency>
          <groupId>com.h2database</groupId>
          <artifactId>h2</artifactId>
@@ -317,7 +336,7 @@
            </plugins>
          </build>
       </profile>
-      
+
       <profile>
          <id>javadoc</id>
          <activation>
@@ -334,11 +353,11 @@
                   <executions>
                      <execution>
                         <id>javadoc-domain-api</id>
-                        <phase>compile</phase>                        
+                        <phase>compile</phase>
                         <goals>
                            <goal>javadoc</goal>
                         </goals>
-                        <configuration>                        
+                        <configuration>
                            <doctitle>RHQ ${project.version} - Domain</doctitle>
                            <reportOutputDirectory>${javadoc.outputDirectory}</reportOutputDirectory>
                            <destDir>domain</destDir>
@@ -358,7 +377,7 @@
             </plugins>
          </build>
       </profile>
-      
+
    </profiles>
 
 </project>
diff --git a/modules/core/gui/pom.xml b/modules/core/gui/pom.xml
index 96a3212..d55fd5a 100644
--- a/modules/core/gui/pom.xml
+++ b/modules/core/gui/pom.xml
@@ -58,12 +58,19 @@
 
       <!-- needed for referenced domain entities that use Hibernate annotations (due to JDK5 bug) -->
       <dependency>
-         <groupId>hibernate-annotations</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-annotations</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope>
          <!-- by JBossAS -->
       </dependency>
+      
+      <dependency>
+         <groupId>org.hibernate</groupId>
+         <artifactId>hibernate-validator-legacy</artifactId>
+         <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
+         <scope>provided</scope>
+      </dependency>      
 
       <dependency>
          <groupId>javax.el</groupId>
@@ -221,4 +228,4 @@
 
    </profiles>
 
-</project>
\ No newline at end of file
+</project>
diff --git a/modules/core/plugindoc/ant-run.xml b/modules/core/plugindoc/ant-run.xml
index b11f84a..24bf94b 100644
--- a/modules/core/plugindoc/ant-run.xml
+++ b/modules/core/plugindoc/ant-run.xml
@@ -20,7 +20,7 @@
          <include name="commons-collections/commons-collections/3.2/commons-collections-3.2.jar" />
          <include name="commons-lang/commons-lang/2.4/commons-lang-2.4.jar" />
          <include name="oro/oro/2.0.7/oro-2.0.7.jar" />
-         <include name="hibernate-annotations/hibernate-annotations/3.2.1.GA/hibernate-annotations-3.2.1.GA.jar" />
+         <include name="hibernate-annotations/hibernate-annotations/${hibernate-annotations.version}/hibernate-annotations-${hibernate-annotations.version}.jar" />
          <include name="javax/persistence/persistence-api/1.0/persistence-api-1.0.jar" />
          <include name="org/apache/maven/maven-plugin-api/2.0.8/maven-plugin-api-2.0.8.jar" />
          <include name="org/apache/maven/maven-project/2.0.8/maven-project-2.0.8.jar" />
diff --git a/modules/core/plugindoc/pom.xml b/modules/core/plugindoc/pom.xml
index 056b66e..81ea2cb 100644
--- a/modules/core/plugindoc/pom.xml
+++ b/modules/core/plugindoc/pom.xml
@@ -52,7 +52,7 @@
       </dependency>
 
       <dependency>
-         <groupId>hibernate-annotations</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-annotations</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope>
@@ -104,6 +104,7 @@
               <tasks>
                 <ant antfile="${basedir}/ant-run.xml" dir="${basedir}" target="package-dist" inheritAll="false" inheritRefs="false">
                    <property name="settings.localRepository" value="${settings.localRepository}" />
+                   <property name="hibernate-annotations.version" value="${hibernate-annotations.version}" />                   
                    <property name="project.version" value="${project.version}" />
                 </ant>
               </tasks>
@@ -118,4 +119,4 @@
     </plugins>
   </build>
 
-</project>
\ No newline at end of file
+</project>
diff --git a/modules/enterprise/gui/portal-war/pom.xml b/modules/enterprise/gui/portal-war/pom.xml
index 7de6682..5712c6d 100644
--- a/modules/enterprise/gui/portal-war/pom.xml
+++ b/modules/enterprise/gui/portal-war/pom.xml
@@ -129,15 +129,15 @@
       </dependency>
 
       <dependency>
-         <groupId>hibernate</groupId>
-         <artifactId>hibernate3</artifactId>
+         <groupId>org.hibernate</groupId>
+         <artifactId>hibernate-core</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
       </dependency>
 
       <!-- used by a test JSP -->
       <dependency>
-         <groupId>hibernate-entitymanager</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-entitymanager</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
@@ -145,7 +145,7 @@
 
       <!-- needed for referenced domain entities that use Hibernate annotations (due to JDK5 bug) -->
       <dependency>
-         <groupId>hibernate-annotations</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-annotations</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
diff --git a/modules/enterprise/gui/webdav-war/pom.xml b/modules/enterprise/gui/webdav-war/pom.xml
index 30c6d11..78c802a 100644
--- a/modules/enterprise/gui/webdav-war/pom.xml
+++ b/modules/enterprise/gui/webdav-war/pom.xml
@@ -77,15 +77,15 @@
 
 
       <dependency>
-         <groupId>hibernate</groupId>
-         <artifactId>hibernate3</artifactId>
+         <groupId>org.hibernate</groupId>
+         <artifactId>hibernate-core</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
       </dependency>
 
       <!-- used by a test JSP -->
       <dependency>
-         <groupId>hibernate-entitymanager</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-entitymanager</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
@@ -93,7 +93,7 @@
 
       <!-- needed for referenced domain entities that use Hibernate annotations (due to JDK5 bug) -->
       <dependency>
-         <groupId>hibernate-annotations</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-annotations</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
diff --git a/modules/enterprise/remoting/cli/pom.xml b/modules/enterprise/remoting/cli/pom.xml
index 6f1d556..77710d5 100644
--- a/modules/enterprise/remoting/cli/pom.xml
+++ b/modules/enterprise/remoting/cli/pom.xml
@@ -25,7 +25,6 @@
       <i18nlog.version>1.0.9</i18nlog.version>
       <log4j.version>1.2.14</log4j.version>
       <persistence-api.version>1.0</persistence-api.version>
-      <hibernate-all.version>1.0.0.Alpha9</hibernate-all.version>
       <opencsv.version>1.8</opencsv.version>
       <testng.version>5.9</testng.version>
    </properties>
@@ -60,6 +59,12 @@
       </dependency>
 
       <dependency>
+         <groupId>org.hibernate</groupId>
+         <artifactId>hibernate-annotations</artifactId>
+         <version>${hibernate-annotations.version}</version>
+      </dependency>
+
+      <dependency>
          <groupId>org.testng</groupId>
          <artifactId>testng</artifactId>
          <version>5.9</version>          
diff --git a/modules/enterprise/remoting/client-api/pom.xml b/modules/enterprise/remoting/client-api/pom.xml
index 0fc95b6..c91af35 100644
--- a/modules/enterprise/remoting/client-api/pom.xml
+++ b/modules/enterprise/remoting/client-api/pom.xml
@@ -177,8 +177,9 @@
       </dependency>
 
       <dependency>
-         <groupId>hibernate-annotations</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-annotations</artifactId>
+         <version>${hibernate-annotations.version}</version>         
       </dependency>
       
    </dependencies>
diff --git a/modules/enterprise/server/container/pom.xml b/modules/enterprise/server/container/pom.xml
index 4ee342f..3dffb74 100644
--- a/modules/enterprise/server/container/pom.xml
+++ b/modules/enterprise/server/container/pom.xml
@@ -110,6 +110,11 @@
 	  <type>zip</type>
       <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
     </dependency>
+    
+	<dependency>
+	 <groupId>org.slf4j</groupId>
+	 <artifactId>slf4j-log4j12</artifactId>
+	</dependency>      
 
   </dependencies>
 
@@ -177,8 +182,15 @@
                   <property name="jtds.version" value="${jtds.version}" />
                   <property name="jsf-api.version" value="${jsf-api.version}" />
                   <property name="jsf-impl.version" value="${jsf-impl.version}" />                  
-                  <property name="hibernate3.version" value="${hibernate3.version}" />
+                  <property name="hibernate-core.version" value="${hibernate-core.version}" />
+                  <property name="hibernate-validator-legacy.version" value="${hibernate-validator-legacy.version}" />
+                  <property name="hibernate-jmx.version" value="${hibernate-jmx.version}" />
+                  <property name="hibernate-annotations.version" value="${hibernate-annotations.version}" />                  
+                  <property name="hibernate-commons-annotations.version" value="${hibernate-commons-annotations.version}" />                  
+                  <property name="hibernate-entitymanager.version" value="${hibernate-entitymanager.version}" />                   
                   <property name="quartz.version" value="${quartz.version}" />
+                  <property name="slf4j-api.version" value="${slf4j-api.version}" /> 
+                  <property name="slf4j-log4j12.version" value="${slf4j-log4j12.version}" />
 
                   <!-- dev/test DB settings (used to init rhq-server.properties if dev profile is active or developer prop is set) -->
                   <property name="rhq.test.ds.connection-url" value="${rhq.test.ds.connection-url}" />
@@ -359,4 +371,4 @@
 
   </profiles>
 
-</project>
\ No newline at end of file
+</project>
diff --git a/modules/enterprise/server/container/src/main/scripts/rhq-container.build.xml b/modules/enterprise/server/container/src/main/scripts/rhq-container.build.xml
index cf7e575..1f05db2 100644
--- a/modules/enterprise/server/container/src/main/scripts/rhq-container.build.xml
+++ b/modules/enterprise/server/container/src/main/scripts/rhq-container.build.xml
@@ -223,13 +223,34 @@
       </delete>
     <copy file="${settings.localRepository}/org/rhq/safe-invoker/${rhq.version}/safe-invoker-${rhq.version}.jar"
            toDir="${jboss.deploy.dir}/jbossws.sar" verbose="true" />
+           
     <copy file="${basedir}/src/main/resources/jbossas/server/default/deploy/jbossws.sar/jbossws.beans/META-INF/jboss-beans.xml"
           toDir="${jboss.deploy.dir}/jbossws.sar/jbossws.beans/META-INF" verbose="true" /> 
 
 
-      <echo>Installing patched hibernate jar ...</echo>
-    <copy file="${settings.localRepository}/hibernate/hibernate3/${hibernate3.version}/hibernate3-${hibernate3.version}.jar"
-          tofile="${jboss.home}/server/default/lib/hibernate3.jar" verbose="true"/>
+    <copy file="${settings.localRepository}/org/hibernate/hibernate-core/${hibernate-core.version}/hibernate-core-${hibernate-core.version}.jar"
+          tofile="${jboss.home}/server/default/lib/hibernate-core.jar" verbose="true"/>
+          
+    <copy file="${settings.localRepository}/org/hibernate/hibernate-validator-legacy/${hibernate-validator-legacy.version}/hibernate-validator-legacy-${hibernate-validator-legacy.version}.jar"
+          tofile="${jboss.home}/server/default/lib/hibernate-validator-legacy.jar" verbose="true"/> 
+          
+    <copy file="${settings.localRepository}/org/hibernate/hibernate-jmx/${hibernate-jmx.version}/hibernate-jmx-${hibernate-jmx.version}.jar"
+          tofile="${jboss.home}/server/default/lib/hibernate-jmx.jar" verbose="true"/>  
+          
+    <copy file="${settings.localRepository}/org/hibernate/hibernate-annotations/${hibernate-annotations.version}/hibernate-annotations-${hibernate-annotations.version}.jar"
+          tofile="${jboss.home}/server/default/lib/hibernate-annotations.jar" verbose="true"/> 
+          
+    <copy file="${settings.localRepository}/org/hibernate/hibernate-commons-annotations/${hibernate-commons-annotations.version}/hibernate-commons-annotations-${hibernate-commons-annotations.version}.jar"
+          tofile="${jboss.home}/server/default/lib/hibernate-commons-annotations.jar" verbose="true"/> 
+          
+    <copy file="${settings.localRepository}/org/hibernate/hibernate-entitymanager/${hibernate-entitymanager.version}/hibernate-entitymanager-${hibernate-entitymanager.version}.jar"
+          tofile="${jboss.home}/server/default/lib/hibernate-entitymanager.jar" verbose="true"/>         
+          
+    <copy file="${settings.localRepository}/org/slf4j/slf4j-api/${slf4j-api.version}/slf4j-api-${slf4j-api.version}.jar"
+          tofile="${jboss.home}/server/default/lib/slf4j-api.jar" verbose="true"/> 
+                
+    <copy file="${settings.localRepository}/org/slf4j/slf4j-log4j12/${slf4j-log4j12.version}/slf4j-log4j12-${slf4j-log4j12.version}.jar"
+          tofile="${jboss.home}/server/default/lib/slf4j-log4j12.jar" verbose="true"/>     
 
       <echo>Installing custom container library...</echo>
     <copy file="${settings.localRepository}/org/rhq/rhq-container-lib/${rhq.version}/rhq-container-lib-${rhq.version}.jar"
diff --git a/modules/enterprise/server/jar/pom.xml b/modules/enterprise/server/jar/pom.xml
index eafa5ae..0a1c8f0 100644
--- a/modules/enterprise/server/jar/pom.xml
+++ b/modules/enterprise/server/jar/pom.xml
@@ -121,20 +121,32 @@
       </dependency>
 
       <dependency>
-         <groupId>hibernate</groupId>
-         <artifactId>hibernate3</artifactId>
+         <groupId>org.hibernate</groupId>
+         <artifactId>hibernate-core</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
       </dependency>
 
       <dependency>
-         <groupId>hibernate-annotations</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-annotations</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
       </dependency>
 
       <dependency>
+         <groupId>org.slf4j</groupId>
+         <artifactId>slf4j-api</artifactId>
+         <scope>provided</scope>
+      </dependency>
+
+      <dependency>
+         <groupId>org.slf4j</groupId>
+         <artifactId>slf4j-log4j12</artifactId>
+         <scope>provided</scope>
+      </dependency>
+
+      <dependency>
          <groupId>javax.mail</groupId>
          <artifactId>mail</artifactId>
          <version>1.3.1</version>
@@ -328,7 +340,7 @@
       </dependency>
 
       <dependency>
-         <groupId>hibernate-entitymanager</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-entitymanager</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>test</scope>
@@ -571,7 +583,7 @@
             </dependency>
          </dependencies>
       </profile>
-   
+
       <profile>
          <id>javadoc</id>
          <activation>
@@ -639,8 +651,8 @@
             </plugins>
          </build>
 
-      </profile>   
+      </profile>
 
    </profiles>
-   
+
 </project>
diff --git a/modules/enterprise/server/safe-invoker/pom.xml b/modules/enterprise/server/safe-invoker/pom.xml
index 8cb3509..dacee8d 100644
--- a/modules/enterprise/server/safe-invoker/pom.xml
+++ b/modules/enterprise/server/safe-invoker/pom.xml
@@ -39,12 +39,12 @@
       </dependency>
 
       <dependency>
-         <groupId>hibernate</groupId>
-         <artifactId>hibernate3</artifactId>
+         <groupId>org.hibernate</groupId>
+         <artifactId>hibernate-core</artifactId>
          <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
          <scope>provided</scope> <!-- by JBossAS -->
       </dependency>
 
    </dependencies>
 
-</project>
\ No newline at end of file
+</project>
diff --git a/modules/plugins/snmptrapd/pom.xml b/modules/plugins/snmptrapd/pom.xml
index b58e0fd..94f6dca 100644
--- a/modules/plugins/snmptrapd/pom.xml
+++ b/modules/plugins/snmptrapd/pom.xml
@@ -201,7 +201,7 @@
       <scope>provided</scope>
     </dependency>
     <dependency>
-      <groupId>hibernate-annotations</groupId>
+      <groupId>org.hibernate</groupId>
       <artifactId>hibernate-annotations</artifactId>
       <!-- NOTE: The version is defined in the root POM's dependencyManagement section. -->
       <scope>provided</scope>
diff --git a/pom.xml b/pom.xml
index 34487d0..9032b58 100644
--- a/pom.xml
+++ b/pom.xml
@@ -61,9 +61,12 @@
     <commons-logging.version>1.1.0.jboss</commons-logging.version>
     <concurrent.version>1.3.4-jboss-update1</concurrent.version> <!-- oswego-concurrent compatible with 4.2.3.GA -->
     <getopt.version>1.0.13</getopt.version>
-    <hibernate3.version>3.2.r14201-2</hibernate3.version>
-    <hibernate-annotations.version>3.2.1.GA</hibernate-annotations.version>
-    <hibernate-entitymanager.version>3.2.1.GA</hibernate-entitymanager.version>
+    <hibernate-core.version>3.3.2.GA</hibernate-core.version>
+    <hibernate-jmx.version>3.3.2.GA</hibernate-jmx.version>  
+    <hibernate-commons-annotations.version>3.1.0.GA</hibernate-commons-annotations.version>
+    <hibernate-annotations.version>3.4.0.GA</hibernate-annotations.version>
+    <hibernate-entitymanager.version>3.4.0.GA</hibernate-entitymanager.version>
+    <hibernate-validator-legacy.version>4.0.2.GA</hibernate-validator-legacy.version>    
     <jaxb-api.version>2.1</jaxb-api.version>
     <jaxb-impl.version>2.1.6</jaxb-impl.version>
     <jsf-api.version>1.2_12</jsf-api.version>
@@ -78,6 +81,8 @@
     <sigar.version>1.6.3.82</sigar.version>
     <quartz.version>1.6.5</quartz.version>
     <jna.version>3.2.2</jna.version>
+    <slf4j-api.version>1.5.8</slf4j-api.version>
+    <slf4j-log4j12.version>1.5.8</slf4j-log4j12.version>    
 
     <!-- defaults for datasource used by dbsetup, unit+integration tests, and dev container build -
          these may be overridden in ~/.m2/settings.xml -->
@@ -267,22 +272,52 @@
       </dependency>
 
       <dependency>
-        <groupId>hibernate</groupId>
-        <artifactId>hibernate3</artifactId>
-        <version>${hibernate3.version}</version>
+        <groupId>org.hibernate</groupId>
+        <artifactId>hibernate-core</artifactId>
+        <version>${hibernate-core.version}</version>
       </dependency>
+      
+      <dependency>
+        <groupId>org.hibernate</groupId>
+        <artifactId>hibernate-jmx</artifactId>
+        <version>${hibernate-jmx.version}</version>
+      </dependency>
+      
+      <dependency>
+        <groupId>org.hibernate</groupId>
+        <artifactId>hibernate-validator-legacy</artifactId>
+        <version>${hibernate-validator-legacy.version}</version>
+      </dependency>      
 
       <dependency>
-         <groupId>hibernate-annotations</groupId>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-annotations</artifactId>
          <version>${hibernate-annotations.version}</version>
       </dependency>
 
       <dependency>
-         <groupId>hibernate-entitymanager</groupId>
+         <groupId>org.hibernate</groupId>
+         <artifactId>hibernate-commons-annotations</artifactId>
+         <version>${hibernate-commons-annotations.version}</version>
+      </dependency>         
+      
+      <dependency>
+         <groupId>org.hibernate</groupId>
          <artifactId>hibernate-entitymanager</artifactId>
          <version>${hibernate-entitymanager.version}</version>
-      </dependency>
+      </dependency>      
+      
+      <dependency>
+         <groupId>org.slf4j</groupId>
+         <artifactId>slf4j-api</artifactId>
+         <version>${slf4j-api.version}</version>
+      </dependency>          
+      
+      <dependency>
+         <groupId>org.slf4j</groupId>
+         <artifactId>slf4j-log4j12</artifactId>
+         <version>${slf4j-log4j12.version}</version>
+      </dependency>           
 
       <dependency>
         <groupId>org.hyperic</groupId>
-- 
1.6.5.2